unit T_BiancoGradient;

//23/10/97
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, EXTCTRLS,Controls, Forms, Dialogs;

type
  TFillStyle=(fsHorizontal,fsVertical,fsSquare,fsEllipse);
  TBiancoGradient = class(Tpanel)
  private
    { Private declarations }
    C:Array[1..6] Of Byte;
    Fs:TFillStyle;
    N:Integer;
    procedure SetN(Value:Integer);
    procedure SetC(Index:INteger;Value:Byte);
    procedure SetFs(Value:TFillStyle);
  protected
    { Protected declarations }
    procedure Paint; override;
  public
    { Public declarations }
   Constructor Create(AOwner:TComponent); OVERRIDE;
  published
    { Published declarations }
   Property Align; 
   Property Steps:Integer read N write SetN;
   Property Style:TFillStyle read fs write SetFs;
   PROPERTY Red2:Byte Index 1 READ C[1] WRITE SETC;
   PROPERTY Red1:Byte Index 4 READ C[4] WRITE SETC;
   PROPERTY Green2:Byte Index 2 READ C[2] WRITE SETC;
   PROPERTY Green1:Byte Index 5 READ C[5] WRITE SETC;
   PROPERTY Blue2:Byte Index 3 READ C[3] WRITE SETC;
   PROPERTY Blue1:Byte Index 6 READ C[6] WRITE SETC;

  end;

procedure Register;

implementation

PROCEDURE TBiancoGradient.SETN(VALUE:Integer);
 BEGIN
  If (N <> Value) and (N>1) Then
   Begin
    N:=VALUE;
    PAINT;
   End;
 END;

procedure TBiancoGradient.SetFs(Value:TFillStyle);
 begin
  if Value<>Fs then
   begin
    Fs:=Value;
    Paint;
   end;
 end;

procedure TBiancoGradient.SetC(Index:Integer;Value:Byte);
 begin
  if Value<>C[Index] then
   begin
    C[Index]:=Value;
    Paint;
   end;
 end;

procedure TBiancoGradient.PAINT;
 var
  dc,cu:array[1..3] of double;
  Dx,Dy:Double;
  a,b:integer;
 BEGIN
  If Random(5000)=0 then
   ShowMessage('Bianchini Marco <bianco@arcanet.it>');
 //delta incremento
  dc[1]:=(abs(c[1]-c[4]))/N;
  dc[2]:=(abs(c[2]-c[5]))/N;
  dc[3]:=(abs(c[3]-c[6]))/N;
  cu[1]:=c[4];
  cu[2]:=c[5];
  cu[3]:=c[6];
  Dx:=Width / N;
  DY:=Height / N;
  With canvas Do
   Begin
    pen.color:=rgb(trunc(cu[1]),trunc(cu[2]),trunc(cu[3]));
    brush.color:=rgb(trunc(cu[1]),trunc(cu[2]),trunc(cu[3]));
    Rectangle(0,0,Width,Height);
    for a:=0 to N-1 do
     begin
      pen.color:=rgb(trunc(cu[1]),trunc(cu[2]),trunc(cu[3]));
      brush.color:=rgb(trunc(cu[1]),trunc(cu[2]),trunc(cu[3]));
      Case Fs Of
       fsVertical:rectangle(Trunc(a*Dx),0,Trunc(a*Dx+Dx),Height);
       fsHorizontal:rectangle(0,Trunc(a*Dy),Width,Trunc(a*Dy+Dy));
       fsSquare:rectangle(Trunc(a*Dx/2),Trunc(a*Dy/2),Width-Trunc(a*Dx/2),Height-Trunc(a*Dy/2));
       fsEllipse:Ellipse(Trunc(a*Dx/2),Trunc(a*Dy/2),Width-Trunc(a*Dx/2),Height-Trunc(a*Dy/2));
      End;
      for b:=1 to 3 do
       cu[b]:=cu[b]+dc[b];
     End;
  end;
 END;

//*********************************************
constructor TBiancoGradient.Create(AOwner:TComponent);
 begin
  inherited Create(AOwner);
  N:=255;
  C[1]:=255;
  randomize;
  C[2]:=255;
  C[3]:=255;
 end;

procedure Register;
begin
  RegisterComponents('Bianco', [TBiancoGradient]);
end;

end.




